'Ursprnglicher Autor: Kleinhirn
'nderungen durch: Stefan_G., J.K., Werner Pilwousek
'Letzte nderung: 26.08.2004
'Letzte nderung: 22.10.2004 Martin Stelzig Drehung 180 fr Casios eingebaut

'Dieses Skript wird auf jedes direkt von der Kamera aus kopierte / verschobene Bild ausgefhrt
'Funktionen:
' - als Fotograf wird der Name eingetragen
' - ein Copyrightvermerk wird aus dem Bilddatum (Jahr) und dem Namen zusammengesetzt
' - falls von der Kamera untersttzt, wird das Bild Verlustfrei gedreht
' - falls Exif-Datum fehlt, wird es vom Dateinderungs-Datum generiert
' - die Datei-Erweiterung wird von Groschreibung auf Kleinschreibung gendert
Option Explicit

Dim Datei
Dim oDatei
Dim Dateiname
Dim Extension
Dim Pfad
Dim Datum
Dim Hersteller
Dim Make

Dim Verzeichnis
Dim Jahr
Dim Orientation

Dim Name
Dim Copyright2
Dim UserComment

Dim fso


'*********************************************************
'* Hier kann das Skript angepasst werden!				*
'*********************************************************
Name = "Autorvorname Autornachname"
Copyright2 = "z.B. E-Mailadresse und/oder Homepage"
UserComment = "Eingelesen und optimiert mit FixFoto (www.j-k-s.com)"
'*********************************************************


Set fso = CreateObject("Scripting.FileSystemObject")

Datei = FF_GetImageName(0)
SplitPath Datei, Pfad, Dateiname, Extension

'nur wenn auch Exif-Daten vorhanden sind weitermachen
If FF_LoadExif(Datei) Then
	'Es heit noch lange nicht, dass wenn LoadExif positiv ist, dass auch Exif-Daten vorhanden sind!
	If FF_HasExif Then
		Jahr = GetYearFromExifTime(FF_GetExifTag("DateTime"))
		If Len(Jahr) = 0 Then Jahr = GetYearFromExifTime(FF_GetExifTag("DateTimeOriginal"))
		If Len(Jahr) = 0 Then Jahr = GetYearFromExifTime(FF_GetExifTag("DateTimeDigitized"))
		
		'Datum von Dateidatum holen
		If Len(Jahr) = 0 Then
			Set oDatei = fso.GetFile(Datei)
			'Datum der letzten nderung(idR Aufnahmedatum wenn unbearbeitet von Kamera transferiert)
			'DateCreated kann falschen Zeitpunkt anzeigen, da bereits die kopierte Datei diesen Wert
			'verndert, auerdem ist er auf der Karte meist nicht vermerkt (FAT16)
			Datum = CStr(Year(oDatei.DateLastModified)) & ":" & CStr(FormatNum(Month(oDatei.DateLastModified), 2)) & ":" & CStr(FormatNum(Day(oDatei.DateLastModified), 2))
			Datum = Datum & " " & CStr(FormatNum(Hour(oDatei.DateLastModified), 2)) & ":" & CStr(FormatNum(Minute(oDatei.DateLastModified), 2)) & ":" & CStr(FormatNum(Second(oDatei.DateLastModified), 2))
			FF_SetExifTag "DateTime", Datum
			FF_SetExifTag "DateTimeOriginal", Datum
			FF_SetExifTag "DateTimeDigitized", Datum
			Jahr = CStr(Year(oDatei.DateLastModified))
			Set oDatei = Nothing
		End If
		'wenn nichts anderes vorhanden ist, das aktuelle Jahr verwenden
		'Anm: Sollte theoretisch nie mehr erreicht werden!
		If Len(Jahr) = 0 Then Jahr = CStr(Year(Now))
		
		FF_SetExifTag "Artist", Name
		FF_SetExifTag "Copyright1","" & Jahr & " " & Name
		FF_SetExifTag "Copyright2", Copyright2
		FF_SetExifTag "UserComment", UserComment
		
		FF_SaveExif Datei
		
		'Das Bild Verlustfrei Drehen um 90, 180 oder 270 Grad (falls von der Kamera untersttzt)
		Orientation = FF_GetExifTag("Orientation")
		
		
		'Anweisung umsetzen um Vorschaubild mitzudrehen
		'fr die Kameras Casio QV4000 + QV5700 + EX-P600
		If Orientation <> "" Then
			'Kamera nach links gekippt -> Drehung von 270 Grad
			If Orientation = "8" Then	  
				FF_RotateFile Datei, 270
			'Kamera nach rechts gekippt -> Drehung von 90 Grad
			ElseIf Orientation = "6" Then
				FF_RotateFile Datei, 90
			'Kamera verkehrt -> Drehung von 180 Grad
			ElseIf Orientation = "3" Then
				FF_RotateFile Datei, 180

			End If
		End If
		
                    

		fso.MoveFile Datei, Pfad & "\" & Dateiname & LCase(Extension)
	End If
End If

Set fso = Nothing

'*********************************************************
' liefert Verzeichnis ohne abschliessendem Backslash,
' Dateinamen und Erweiterung mit einleitendem Punkt
'*********************************************************
Sub SplitPath(path, ByRef dirc, ByRef file, ByRef ext)
  dirc = fso.GetParentFolderName(path)
  file = fso.GetBaseName(path)
  ext = "." & fso.GetExtensionName(path)
End Sub
'*********************************************************
' liefert Jahr aus ExifZeit
'*********************************************************
Function GetYearFromExifTime(sDatum)
	GetYearFromExifTime = ""
	If Len(sDatum) > 0 Then
		If IsNumeric(Left(sDatum, 4)) Then
			GetYearFromExifTime = CStr(CLng(Left(sDatum, 4)))
		End If
	End If
End Function
'*********************************************************
' Formatiert Zahlen mit fhrenden Nullen
'*********************************************************
Function FormatNum(vNumber, lDigits)
	If Len(CStr(vNumber)) >= lDigits Then 
		FormatNum = vNumber
		Exit Function
	End If
	FormatNum = Right(String(lDigits, "0") & vNumber, lDigits)
End Function
